/**
 * スケジュールの際に、使うショートカット機能

Windows
・Ctrl + クリック　⇒　出席

・Windows + クリック　⇒　出席

・Alt + クリック　⇒　欠席

・Ctrl + クリック　⇒　ToDo完了

・Windows + クリック　⇒　ToDo完了

MacBook
・Command + クリック　⇒　出席

・Alt + クリック　⇒　欠席

・Command + クリック　⇒　ToDo完了

 */

$(document).ready(function () {
  const RAKUSUKE_SCHS = document.querySelectorAll(
    ".schLiCommon.showPart:not(.tourTarget)"
  );

  const RAKUSUKE_TODOSCHS = document.querySelectorAll(".todoLiCommon.showPart");

  const RAKUSUKE_WESCHS = document.querySelectorAll("[class=schLiCommon]");

  const RAKUSUKE_WETODOSCHS = document.querySelectorAll("[class=todoLiCommon]");

  const RAKUSUKE_SCHS_MO_ANKEN = document.querySelectorAll(
    ".schLiCommon.showPart.tourTarget"
  );

  const RAKUSUKE_SCHS_WE_ANKEN = [
    ...document.querySelectorAll(".schLiCommon.tourTarget"),
  ].filter((el) => !el.classList.contains("showPart"));

  let year;
  let month;
  let day;

  function date(target) {
    year = target.firstElementChild.outerHTML
      .match(/hCODC\(.*?\)/)[0]
      .replaceAll(/^hCODC\(|\)$/g, "")
      .split(",")
      .at(-4)
      .replaceAll("\\", "")
      .replaceAll("'", "");
    month = target.firstElementChild.outerHTML
      .match(/hCODC\(.*?\)/)[0]
      .replaceAll(/^hCODC\(|\)$/g, "")
      .split(",")
      .at(-3)
      .replaceAll("\\", "")
      .replaceAll("'", "");
    day = target.firstElementChild.outerHTML
      .match(/hCODC\(.*?\)/)[0]
      .replaceAll(/^hCODC\(|\)$/g, "")
      .split(",")
      .at(-2)
      .replaceAll("\\", "")
      .replaceAll("'", "");
  }

  let clickPara;
  let schPara;
  let imgage;
  let employee_code;

  function para(target) {
    clickPara = target.firstElementChild;
    schPara = clickPara.outerHTML
      .match(/hCODC\(.*?\)/)[0]
      .replaceAll(/^hCODC\(|\)$/g, "")
      .split(",")
      .at(-1)
      .replaceAll("\\", "")
      .replaceAll("'", "");
    imgage = target.querySelector(".schRecCommon img");
    employee_code = clickPara.outerHTML
      .match(/hCODC\(.*?\)/)[0]
      .replaceAll(/^hCODC\(|\)$/g, "")
      .split(",")
      .at(-7)
      .replaceAll("\\", "")
      .replaceAll("'", "");
  }

  let todo;
  let image;

  function todoPara(target) {
    todo = target.firstElementChild.outerHTML
      .match(/hCODC\(.*?\)/)[0]
      .split(/[;&]/)
      .at(-5);
    image = target.querySelector(".todoRecCommon img");
  }

  function getPath() {
    const url = location.protocol + "//" + location.host + location.pathname;
    return url;
  }

  function getTodoFinIcon() {
    const contextName = eSMSystemValue.requestUrl.split(/[/]/).at(-2);
    const todoFinIcon = `/${contextName}/esales_res/css/default//images/stat_todo_finish.gif`;
    return todoFinIcon;
  }

  function getmyEmpCode() {
    const myEmpCode = eSMSystemValue.employeeCode;
    return myEmpCode;
  }

  function getParaSch(target) {
    para(target);

    date(target);
  }

  function getParaTodo(target) {
    para(target);

    date(target);

    todoPara(target);
  }

  function getAttendMonUrl(target) {
    getParaSch(target);

    const path = getPath();

    const attendMonUrl = `${path}?page=plan_modify&employee_code=${employee_code}&sch_code=${schPara}&user_sch_code=${schPara}&command=reply&icon_type=1&from_chip=true&iTop=128&iLeft=0&date=${year}${month}${day}&mode=mo&multiple=false&modal=`;

    return attendMonUrl;
  }

  function getAbsenceMonUrl(target) {
    getParaSch(target);

    const path = getPath();

    const absenceMonUrl = `${path}?page=plan_modify&employee_code=${employee_code}&sch_code=${schPara}&user_sch_code=${schPara}&command=reply&icon_type=2&from_chip=true&iTop=128&iLeft=0&date=${year}${month}${day}&mode=mo&multiple=false&modal=`;

    return absenceMonUrl;
  }

  function getIconMonPara(target) {
    getParaSch(target);

    const path = getPath();

    const iconMonPara = `${path}?page=plan_modify&command=&sch_code=${schPara}&date=${year}-${month}-${day}&mode=mo&multiple=false&iTop=155&iLeft=0&employee_code=${employee_code}&prevPage=null&tag_flg=false&from_calendar_portal=true&year=${year}&month=${month}&day=${day}`;

    return iconMonPara;
  }

  function getMonTodoURL(target) {
    getParaTodo(target);

    const path = getPath();

    const monTodo = `${path}?page=todo_sch&mode=mo&multiple=false&employee_code=${employee_code}&${todo}&command=edit&FromPage=tiphelp&cmd=complete&day_to_show=${year}${month}${day}&modal=&iTop=196&iLeft=0`;

    return monTodo;
  }

  function getAttendCaleUrl(target) {
    getParaSch(target);

    const path = getPath();

    const attendCaleUrl = `${path}?page=plan_modify&employee_code=${employee_code}&sch_code=${schPara}&user_sch_code=${schPara}&command=reply&icon_type=1&from_chip=true&iTop=128&iLeft=0&date=${year}${month}${day}&mode=we&multiple=false&modal=`;

    return attendCaleUrl;
  }

  function getOtherAttendCale(target) {
    getParaSch(target);

    const path = getPath();

    const otherAttendCale = `${path}?page=plan_modify&employee_code=${employee_code}&sch_code=${schPara}&user_sch_code=-1&command=reply&icon_type=1&from_chip=true&iTop=128&iLeft=0&date=${year}${month}${day}&mode=we&multiple=false&modal=`;

    return otherAttendCale;
  }

  function getAbsenceWeUrl(target) {
    getParaSch(target);

    const path = getPath();

    const absenceWeUrl = `${path}?page=plan_modify&employee_code=${employee_code}&sch_code=${schPara}&user_sch_code=${schPara}&command=reply&icon_type=2&from_chip=true&iTop=128&iLeft=0&date=${year}${month}${day}&mode=we&multiple=false&modal=`;

    return absenceWeUrl;
  }

  function getIconWePara(target) {
    getParaSch(target);

    const path = getPath();

    const iconWePara = `${path}?page=plan_modify&command=&sch_code=${schPara}&date=${year}-${month}-${day}&mode=we&multiple=false&iTop=155&iLeft=0&employee_code=${employee_code}&prevPage=null&tag_flg=false&from_calendar_portal=true&year=${year}&month=${month}&day=${day}`;

    return iconWePara;
  }

  function getWeTodo(target) {
    getParaSch(target);

    const path = getPath();

    const weTodo = `${path}?page=todo_sch&mode=we&multiple=false&employee_code=${employee_code}&${todo}&command=edit&FromPage=tiphelp&cmd=complete&day_to_show=${year}${month}${day}&modal=&iTop=0&iLeft=0`;

    return weTodo;
  }

  RAKUSUKE_SCHS.forEach((target) => {
    target.addEventListener(
      "click",
      (e) => {
        const attendMonUrl = getAttendMonUrl(target);
        const iconMonPara = getIconMonPara(target);
        const absenceMonUrl = getAbsenceMonUrl(target);

        if (e.ctrlKey == true || e.metaKey == true) {
          fetch(iconMonPara)
            .then((res) => {
              return res.text();
            })
            .then((data) => {
              const parser = new DOMParser();
              const doc = parser.parseFromString(data, "text/html");
              const first = doc.querySelector("#schedule_items");
              const icon = first
                .querySelector(".figTableInputFormat")
                .querySelector("table tbody tr td p img").src;
              const backColor = first
                .querySelector(".figTableInputFormat")
                .querySelector("table tbody tr td p").style.backgroundColor;
              imgage.setAttribute("src", icon);
              target.style.cssText = `background-color: ${backColor}`;
            });

          e.stopPropagation();

          fetch(attendMonUrl);
        } else if (e.altKey == true) {
          e.stopPropagation();

          target.remove("schLiCommon showPart");

          fetch(absenceMonUrl);
        }
      },
      true
    );
  });

  RAKUSUKE_TODOSCHS.forEach((target) => {
    target.addEventListener(
      "click",
      (e) => {
        const moTodoFinIcon = getTodoFinIcon();

        const monTodo = getMonTodoURL(target);

        if (e.ctrlKey == true || e.metaKey == true) {
          e.stopPropagation();

          image.setAttribute("src", moTodoFinIcon);

          fetch(monTodo);
        }
      },
      true
    );
  });

  RAKUSUKE_WESCHS.forEach((target) => {
    target.addEventListener(
      "click",
      (e) => {
        const myEmpCode = getmyEmpCode();

        const attendCaleUrl = getAttendCaleUrl(target);
        const otherAttendCale = getOtherAttendCale(target);
        const absenceWeUrl = getAbsenceWeUrl(target);
        const iconWePara = getIconWePara(target);

        if (e.ctrlKey == true || e.metaKey == true) {
          if (myEmpCode == employee_code) {
            fetch(iconWePara)
              .then((res) => {
                return res.text();
              })
              .then((data) => {
                const parser = new DOMParser();
                const doc = parser.parseFromString(data, "text/html");
                const first = doc.querySelector("#schedule_items");
                const icon = first
                  .querySelector(".figTableInputFormat")
                  .querySelector("table tbody tr td p img").src;
                const backColor = first
                  .querySelector(".figTableInputFormat")
                  .querySelector("table tbody tr td p").style.backgroundColor;
                imgage.setAttribute("src", icon);
                target.style.cssText = `background-color: ${backColor}`;
              });

            e.stopPropagation();

            fetch(attendCaleUrl);
          } else {
            e.stopPropagation();
            async function othersSch() {
              await fetch(otherAttendCale);
              location.reload();
            }

            othersSch();
          }
        } else if (e.altKey == true) {
          if (myEmpCode == employee_code) {
            e.stopPropagation();

            clickPara.style.display = "none";
            target.style.cssText = "background-color:";

            fetch(absenceWeUrl);
          } else {
            return;
          }
        }
      },
      true
    );
  });

  RAKUSUKE_WETODOSCHS.forEach((target) => {
    target.addEventListener(
      "click",
      (e) => {
        const weTodoFinIcon = getTodoFinIcon();

        const weTodo = getWeTodo(target);

        if (e.ctrlKey == true || e.metaKey == true) {
          e.stopPropagation();

          image.setAttribute("src", weTodoFinIcon);

          fetch(weTodo);
        }
      },
      true
    );
  });

  RAKUSUKE_SCHS_MO_ANKEN.forEach((target) => {
    target.addEventListener(
      "click",
      (e) => {
        const attendMonUrl = getAttendMonUrl(target);
        const iconMonPara = getIconMonPara(target);
        const absenceMonUrl = getAbsenceMonUrl(target);

        if (e.ctrlKey == true || e.metaKey == true) {
          fetch(iconMonPara)
            .then((res) => {
              return res.text();
            })
            .then((data) => {
              const parser = new DOMParser();
              const doc = parser.parseFromString(data, "text/html");
              const first = doc.querySelector("#schedule_items");
              const icon = first
                .querySelector(".figTableInputFormat")
                .querySelector("table tbody tr td p img").src;
              const backColor = first
                .querySelector(".figTableInputFormat")
                .querySelector("table tbody tr td p").style.backgroundColor;
              imgage.setAttribute("src", icon);
              target.style.cssText = `background-color: ${backColor}`;
            });

          e.stopPropagation();

          fetch(attendMonUrl);
        } else if (e.altKey == true) {
          e.stopPropagation();

          target.remove("schLiCommon showPart");

          fetch(absenceMonUrl);
        }
      },
      true
    );
  });

  RAKUSUKE_SCHS_WE_ANKEN.forEach((target) => {
    target.addEventListener(
      "click",
      (e) => {
        const myEmpCode = getmyEmpCode();

        const attendCaleUrl = getAttendCaleUrl(target);
        const otherAttendCale = getOtherAttendCale(target);
        const absenceWeUrl = getAbsenceWeUrl(target);
        const iconWePara = getIconWePara(target);

        if (e.ctrlKey == true || e.metaKey == true) {
          if (myEmpCode == employee_code) {
            fetch(iconWePara)
              .then((res) => {
                return res.text();
              })
              .then((data) => {
                const parser = new DOMParser();
                const doc = parser.parseFromString(data, "text/html");
                const first = doc.querySelector("#schedule_items");
                const icon = first
                  .querySelector(".figTableInputFormat")
                  .querySelector("table tbody tr td p img").src;
                const backColor = first
                  .querySelector(".figTableInputFormat")
                  .querySelector("table tbody tr td p").style.backgroundColor;
                imgage.setAttribute("src", icon);
                target.style.cssText = `background-color: ${backColor}`;
              });

            e.stopPropagation();

            fetch(attendCaleUrl);
          } else {
            e.stopPropagation();
            async function othersSch() {
              await fetch(otherAttendCale);
              location.reload();
            }

            othersSch();
          }
        } else if (e.altKey == true) {
          e.stopPropagation();

          clickPara.style.display = "none";
          target.style.cssText = "background-color:";

          fetch(absenceWeUrl);
        }
      },
      true
    );
  });
});
